//+------------------------------------------------------------------+
//|                                          ME_CorrelationIndex.mq4 |
//|                                                          pronych |
//+------------------------------------------------------------------+
#include <stdlib.mqh>
#property copyright "pronych"
#property  indicator_separate_window
#property  indicator_buffers 5
#property indicator_color1 Aquamarine
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Green
#property indicator_color5 Yellow
#property indicator_width1           1
#property indicator_width2           1
#property indicator_width3           1
#property indicator_width4           1
#property indicator_width5           1

#define ShortNamePrefix             "ME_ASPREAD"    //  
#define FilePrefix                  "ME_"    //  
//#define TotalIndexListFileName      "ME_indexes_list.set"    //       
//#define TotalCurrencyListFileName   "ME_currency_list.set" //      
#define CorrListFilePreName         "me_arbitr_symbol_" //      

#define LAST_UPPER                  +1
#define LAST_NONE                    0
#define LAST_LOWER                  -1
//---- indicator buffers
extern double CorrectDelta         = 0;
extern double LevelUP              =+160;
extern double LevelDN              =-160;

string Symbols;
int    SymbolsCnt=0;
double SymIndex[];
double CorrIndex[];
double LH[];
double LL[];
double Signal[];

string Sym2;
double ItemIndex[];
int SymbolsSignOf[];
int CurrCnt;

int ItWindow=1;

double LastValue;//   (Signal).   ApproximateProfit
double ApproximateProfit;//   ,   
int    Turns;              // 
//int TFNum[10]={0,PERIOD_M1,PERIOD_M5,PERIOD_M15,PERIOD_M30,PERIOD_H1,PERIOD_H4,PERIOD_D1,PERIOD_W1,PERIOD_MN1};//     
double TickSize;
double MaxValue=0;
//datetime RefreshEveryOf[10];
string SymbolsFile        ="";
string Sym,SymPartL,SymPartR;
int MarketType;
bool FirstStart=true;
double StartPriceSym;
datetime StartBarTime;
int      LastPosition=0;
//double   MedianValue=0;
//#include <me_visualisation_v1.mq4>
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
LastPosition=0;ApproximateProfit=0;LastValue=0;Turns=0;// 
//---- additional buffers are used for counting
int handle;Sym=Symbol();SymPartL=StringSubstr(Sym,0,3);SymPartR=StringSubstr(Sym,3);
MarketType=MarketInfo(Sym,MODE_PROFITCALCMODE);
TickSize=MarketInfo(Sym,MODE_TICKSIZE);

    //-----------------------------------------------------
SymbolsFile=CorrListFilePreName+Sym+".csv";
   handle=FileOpen(SymbolsFile,FILE_CSV|FILE_READ);
  if(handle>-1)//  
  {
  Sym2=FileReadString(handle);
  Sym2=StringTrimLeft(StringTrimRight(Sym2));
  FileClose(handle);
  }
  else//   
  {
    string sStr="EURUSD";
    handle=FileOpen(SymbolsFile,FILE_CSV|FILE_WRITE);
    if(handle!=-1){FileWrite(handle,sStr);FileClose(handle);}
    Comment(StringConcatenate("   <",SymbolsFile,">   !"));
    Print(StringConcatenate("   <",SymbolsFile,">   !"));
  }
    //-----------------------------------------------------
   IndicatorBuffers(5);
//---- indicator buffers mapping
   SetIndexBuffer(0, SymIndex);
   SetIndexBuffer(1, CorrIndex);
   SetIndexBuffer(2, LH);
   SetIndexBuffer(3, LL);
   SetIndexBuffer(4, Signal);

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
//---- drawing settings
SetIndexStyle(0,DRAW_HISTOGRAM);
SetIndexStyle(1,DRAW_HISTOGRAM);
SetIndexStyle(2,DRAW_LINE);
SetIndexStyle(3,DRAW_LINE);
SetIndexStyle(4,DRAW_SECTION);
//---- name for DataWindow and indicator subwindow label

string tmp="";
tmp=Sym2;

if (tmp=="")tmp="NO SYMBOL!!!";
   IndicatorShortName(ShortNamePrefix+" ( " +tmp+ ")");
//---- initialization done
   SetIndexLabel(0,"Spread of "+Sym2);
   SetIndexLabel(1,"Spread of "+Sym2 + "no bars");
   SetIndexLabel(2,"LH");
   SetIndexLabel(3,"LL");
   SetIndexLabel(4,"Signal");
   SetLevelValue(0,100);
   SetLevelValue(1,200);
   SetLevelValue(2,-100);
   SetLevelValue(3,-200);
   return(0);
  }
//+----------------------------------------------start()--------------------------------------------+
int start()
{
if(Sym2=="")return;//
   string CurSym=Sym2;// 
   int    limit;
   int    counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//----
    for(int i=0; i<=limit; i++)
    {
     int CurSIndex=0;double CIndex=0;double ItemCurValue=0;
      datetime BarTime=iTime(Sym,0,i);//     
    //-------------------------       -------------------------
      double CurValue=iClose(Sym,0,i);//    
      
      int ItemBar=iBarShift(CurSym,0,BarTime,true);//    ,   ,  -1
      
      if(ItemBar>-1) //        
         {
         ItemCurValue=iClose(CurSym,0,ItemBar);//   
         SymIndex[i]=CorrectDelta+(ItemCurValue-CurValue)/TickSize;//    
         CorrIndex[i]=0.0;//  
         }
      else           //        
         {
         ItemCurValue=iClose(CurSym,0,iBarShift(CurSym,0,BarTime,false));//  ,   
         CorrIndex[i]=CorrectDelta+(ItemCurValue-CurValue)/TickSize;//     
         SymIndex[i]=CorrIndex[i];//  
         }
    }
   double LUP=LevelUP;
   double LDN=LevelDN;

    for( i=limit; i>=0; i--)//  
    {
    LH[i]=LUP;//    
    LL[i]=LDN;//     
      if(CorrIndex[i]!=0)continue;// ,     (  ),   
         //---------------------------------------------------------------------
          if(LastPosition==LAST_NONE)     //   !!
            {
               if(SymIndex[i]>LH[i])     //   
               {
               Signal[i]=LH[i];          //     ( )
               LastPosition=LAST_UPPER;   //,     -
               }         
               if(SymIndex[i]<LL[i])     //   
               {
               Signal[i]=LL[i];          //     ( )
               LastPosition=LAST_LOWER;   //,     -
               }
            LastValue=Signal[i];          //   
            Turns=0;                      // 
            ApproximateProfit=0;          //   
//Print(Turns,". StartTime=",TimeToStr(iTime(Sym,0,i))," ApproximateProfit=",ApproximateProfit," LastValue=",LastValue," LastPosition=",LastPosition);
            continue;                     //  ,     
            }//,    
         //---------------------------------------------------------------------
         if(LastPosition==LAST_LOWER && SymIndex[i]>LH[i])  //     ,  
         {                                                  //    ,   
         Signal[i]=LH[i];                                   //     ( )
         ApproximateProfit+=(Signal[i]-LastValue);          //     
         LastValue=Signal[i];                               //    
         LastPosition=LAST_UPPER;                           //,     -
         Turns++;                                           // 
//Print(Turns,". ApproximateProfit=",ApproximateProfit," LastValue=",LastValue," LastPosition=",LastPosition);
         }
                                                            //
         if(LastPosition==LAST_UPPER && SymIndex[i]<LL[i])  //     ,  
         {                                                  //    ,   
         Signal[i]=LL[i];                                   //     ( )
         ApproximateProfit+=(LastValue-Signal[i]);          //     
         LastValue=Signal[i];                               //    
         LastPosition=LAST_LOWER;                           //,     -
         Turns++;                                           // 
//Print(Turns,". ApproximateProfit=",ApproximateProfit," LastValue=",LastValue," LastPosition=",LastPosition);
         }
    }
ObjLabel("AS_INFO",1,1,3,StringConcatenate("=",Turns,"   =", ApproximateProfit,""),White,false,true,false ,ItWindow);

//" =",Turns," =", ApproximateProfit,"")
//Comment("=",Turns," =", ApproximateProfit," ");

//if(!FirstStart)
//{
//if(Signal[0]>LH[0])GlobalVariableSet("ME/AF/"+Sym+"&"+CurSym,+1);
//if(Signal[0]<LL[0])GlobalVariableSet("ME/AF/"+Sym+"&"+CurSym,-1);
//}
//CalculateStatistic(0);//   .      (0= ,    )
 //---- done
FirstStart=false;
return(0);
}
//+------------------------------------------------------------------+
int StringDisassemble(string &ArrOf[],string Str,string Delimiter=";",bool Trim=true)
{//   
int DelimiterPos=-1,DelimiterPrev=0;int strlen=StringLen(Str);int ArrIndex=0;//string tmp="";
ArrayResize(ArrOf,0);
   while (true)
   {
   DelimiterPos=StringFind(Str,Delimiter,DelimiterPos+1);
   ArrayResize(ArrOf,ArrIndex+1);
   ArrOf[ArrIndex]=StringSubstr(Str, DelimiterPrev, DelimiterPos-DelimiterPrev) ;
   if(DelimiterPos==-1)break;
   ArrIndex++;DelimiterPrev=DelimiterPos+1;
   }
ArrOf[ArrIndex]=StringSubstr(Str, DelimiterPrev);
if(ArrOf[ArrIndex]!="")ArrIndex++;
if(Trim){for (DelimiterPos=0;DelimiterPos<ArrIndex;DelimiterPos++)ArrOf[DelimiterPos]=StringTrimRight(StringTrimLeft(ArrOf[DelimiterPos]));}
//for (DelimiterPos=0;DelimiterPos<ArrIndex;DelimiterPos++)tmp=tmp+ArrOf[DelimiterPos];
//Comment(Str + "\n" + tmp + "\n" + DelimiterPrev  + "\n" + (strlen));
return(ArrIndex);
}
/////////////////////////////  ReadCSV  /////////////////////////////
int ReadCSV(string FName,string &ArrOf[],string Except="",string Delimiter=";",bool Trim=true)
{//    .    ,  -1
int ICnt=0;string Item="";ArrayResize(ArrOf,ICnt);
int handle=FileOpen(FName,FILE_CSV|FILE_READ,Delimiter);
  if(handle<0)return(-1);//   
   while (!FileIsEnding(handle))
   {
   Item=FileReadString(handle);
   if(Trim)Item=StringTrimLeft(StringTrimRight(Item));
   if(Except!=""){if(StringFind(Item,Except)>-1)continue;}
   if(Item=="")continue;
   ICnt++;ArrayResize(ArrOf,ICnt);ArrOf[ICnt-1]=Item;
   if(FileIsEnding(handle))break;
   }
   FileClose(handle);
return(ICnt);
}
/////////////////////////////  WriteCSV  /////////////////////////////
int WriteCSV(string FName,string &ArrOf[])
{
int i=ArraySize(ArrOf);
int handle=FileOpen(FName,FILE_CSV|FILE_WRITE,';');
    for(int f=0; f<i;f++)FileWrite(handle,ArrOf[f]);
    if(handle!=-1)FileClose(handle);
return(i);
}
///////////////////////////  SymbolsFilter  ///////////////////////////
int SymbolsFilter(string &ArrOf[],string fltStr1,string fltStr2="")
{//
int i=ArraySize(ArrOf);int f;int sSet=0;
   for(f=0;f<i;f++)//     :)
   {// .  ,     
    if(StringFind(ArrOf[f],fltStr1)>-1)continue;   //   ,   
    else{                                          //  
    if(fltStr2==""){ArrOf[f]="";continue;}//   ,   
    if(StringFind(ArrOf[f],fltStr2)==-1){ArrOf[f]="";}//     ,   
        }// .   ,     
   }//      
   for(f=0;f<i;f++)//      
   {//    
   if(ArrOf[f]!=""){ArrOf[sSet]=ArrOf[f];sSet++;}//          
   }
ArrayResize(ArrOf,sSet);
return(sSet);
}
///////////////////////////  SymbolsSignReplace  ///////////////////////////
int SymbolsSignReplace(string &ArrOf[],int &ArrSgnOf[])//   SymbolsSignPlace
{//     ArrOf    -,  ArrSgnOf=-1    
int f;string CharSign="";
int i=ArraySize(ArrOf);//  
ArrayResize(ArrSgnOf,i);//     ,   
   for(f=0;f<i;f++)// 
   {
   CharSign=StringSubstr(ArrOf[f],0,1);//      
   if(CharSign=="-"){ArrSgnOf[f]=-1;ArrOf[f]=StringSubstr(ArrOf[f],1);continue;}//  '-',   
   if(CharSign=="+"){ArrSgnOf[f]=+1;ArrOf[f]=StringSubstr(ArrOf[f],1);continue;}//  '+',  
   //     ,    (      )
    ArrSgnOf[f]=+1;//   '+',   ,    
    if(MarketType==0 && StringLen(Sym)==6)//       (6 )
    {//    
    if(SymPartL==StringSubstr(ArrOf[f],3,0))ArrSgnOf[f]=-1;//       ,  -1
    if(SymPartR==StringSubstr(ArrOf[f],0,3))ArrSgnOf[f]=-1;//        ,  -1
    }//    ,   .   ,   "+"
   }
return(1);
}
///////////////////////////  SymbolsSignPlace  ///////////////////////////
int SymbolsSignPlace(string &ArrOf[],int &ArrSgnOf[])//   SymbolsSignReplace
{// +1  -1  ArrSgnOf    ArrOf,   +  - (0   )
int f;string CharSign="";
int i=ArraySize(ArrOf);//  
   for(f=0;f<i;f++)// 
   {//         
   if(ArrSgnOf[f]==-1)ArrOf[f]=StringConcatenate("-",ArrOf[f]);// ,  
   else               ArrOf[f]=StringConcatenate("+",ArrOf[f]);//   
   }
return(1);
}
/////////////////////////////////////// PercentGain /////////////////////////////////////////////
double PercentGain(double Before, double After)
{//  
if(Before*(After-Before)==0)return(0.0);
return(100/Before*(After-Before));
}
/////////////////////////////////////////////////////////ObjLabel/////////////////////////////////////////////////////////////////
bool ObjLabel(string ObjName,int X=-1,int Y=-1,int Corner=-1,string ObjComment="",int clr=White, bool delete=false,bool back=true, bool SO=false ,int window=0)
{
       //----
ObjName="ME_"+ ObjName;
if(delete){if((ObjectFind(ObjName)!=-1)) {ObjectDelete(ObjName);}return(false);}

       if(ObjectFind(ObjName) == -1) ObjectCreate(ObjName, OBJ_LABEL,window,0,0);
       if(X!=-1)ObjectSet(ObjName, OBJPROP_XDISTANCE, X);
       if(Y!=-1)ObjectSet(ObjName, OBJPROP_YDISTANCE, Y);
       ObjectSet(ObjName, OBJPROP_CORNER, Corner);
       ObjectSet(ObjName, OBJPROP_BACK, back);
       ObjectSetText(ObjName, ObjComment, 7, "Arial", clr);
}
// , ,  ..